#!/bin/bash
#
#

LOGFILE=$1
[ -z "${LOGFILE}" ] && exit 1

echo "mmiotrace script V0.1 starting..."
echo
echo "Running kernel:"
uname -a
echo
if ! [ -d /sys/kernel/debug/tracing ]; then
	echo "Oops, no tracing support or debugfs not mounted!"
	exit 1
fi

echo "Starting MMIOtrace ..."
echo mmiotrace > /sys/kernel/debug/tracing/current_tracer
echo "Logging MMIO trace ..."
cat /sys/kernel/debug/tracing/trace_pipe > ${LOGFILE} &
echo
echo "Setting first marker [Tracing Start]"
echo "Tracing Start" > /sys/kernel/debug/tracing/trace_marker
echo
echo "Loading nvidia kernel module"
modprobe nvidia
echo "Setting second marker [nvidia Loaded]"
echo "nvidia Loaded" > /sys/kernel/debug/tracing/trace_marker
echo
echo "Waiting 30 seconds"
sleep 30
echo "Setting third marker [preparing for STR]"
echo "preparing for STR" > /sys/kernel/debug/tracing/trace_marker
sync
echo mem > /sys/power/state
echo "Setting fourth marker [resumed from STR]"
echo "resumed from STR" > /sys/kernel/debug/tracing/trace_marker
echo
echo "Waiting 30 seconds"
sleep 30
echo "Setting fifth marker [stopping tracing]"
echo "stopping tracing" > /sys/kernel/debug/tracing/trace_marker
sleep 1
echo nop > /sys/kernel/debug/tracing/current_tracer
echo
echo "Killing cat if it's still running"
killall cat
echo
echo Done

